#ifndef __VOLUME_CONTROL_HEADER__
#define __VOLUME_CONTROL_HEADER__

#define BALANCE_STEP	1

class CVolumeControl
{
	HMIXER m_hMixer;	// Mixer handle used in mixer API calls.
	HWND m_hCallBackHwnd;
	int m_MixerID;

	typedef vector<MIXERCONTROL> MIXERCONTROLvector;
	typedef vector<MIXERCONTROL>::iterator MIXERCONTROLiterator;

	MIXERCONTROLvector m_vLines;
	MIXERCONTROLvector m_vMutes;

	void GetLineControls(MIXERLINE &mxl);

public:

	CVolumeControl();
	void Init(HWND hWnd, int MixerID);
	~CVolumeControl();
	void GetVolume(int channel, int &left, int &right);
	void SetVolume(int channel, int left, int right);
	void ChangeBalance(int channel, int value);
	void ChangeVolume(int channel, int value);
	void VolumeUp(int channel, int nVolumeStep);
	void VolumeDown(int channel, int nVolumeStep);
	void SetMute(int channel, bool bMute);
	bool GetMute(int channel);
	void BalanceLeft(int channel, int nBalanceStep);
	void BalanceRight(int channel, int nBalanceStep);
	void ReInit();
	int m_nCode;
};

class CVolumeControls
{
private:
	int m_Cnt;
	CVolumeControl* m_Mixers;
	bool CheckMixerRange(int mixid);
	void ReadRCSteps();
public:
	static int g_nVolumeStep, g_nBalanceStep;
	CVolumeControls(HWND hWnd);
	~CVolumeControls();
	int m_nCode;
	void GetVolume(int mixid, int channel, int &left, int &right);
	void SetVolume(int mixid, int channel, int left, int right);
	void ChangeBalance(int mixid, int channel, int value);
	void ChangeVolume(int mixid, int channel, int value);
	void VolumeUp(int mixid, int channel, int nVolumeStep = g_nVolumeStep);
	void VolumeDown(int mixid, int channel, int nVolumeStep = g_nVolumeStep);
	void SetMute(int mixid, int channel, bool bMute);
	bool GetMute(int mixid, int channel);
	void BalanceLeft(int mixid, int channel, int nBalanceStep = g_nVolumeStep);
	void BalanceRight(int mixid, int channel, int nBalanceStep = g_nBalanceStep);
	void ReInit();
};

#endif
